/** 
 * AlignFrame.java
 *
 * Description:	
 * @author			koadman
 * @version			
 */

package org.gel.mauve;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class AlignFrame extends java.awt.Frame {

// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
	// member declarations
	javax.swing.JPanel parameterPanel = new javax.swing.JPanel();
	javax.swing.JCheckBox defaultSeedCheckBox = new javax.swing.JCheckBox();
	javax.swing.JCheckBox determineLCBsCheckBox = new javax.swing.JCheckBox();
	javax.swing.JSlider seedSlider = new javax.swing.JSlider();
	javax.swing.JLabel merSizeLabel = new javax.swing.JLabel();
	javax.swing.JCheckBox recursiveCheckBox = new javax.swing.JCheckBox();
	javax.swing.JLabel minRangeLabel = new javax.swing.JLabel();
	javax.swing.JTextField minRangeText = new javax.swing.JTextField();
	javax.swing.JLabel islandSizeLabel = new javax.swing.JLabel();
	javax.swing.JTextField islandSizeText = new javax.swing.JTextField();
	javax.swing.JLabel backboneGapSizeLabel = new javax.swing.JLabel();
	javax.swing.JTextField backboneGapSizeText = new javax.swing.JTextField();
	javax.swing.JLabel backboneSizeLabel = new javax.swing.JLabel();
	javax.swing.JTextField backboneSizeText = new javax.swing.JTextField();

	public javax.swing.JButton alignButton = new javax.swing.JButton();

	javax.swing.JPanel sequencesPanel = new javax.swing.JPanel();
	javax.swing.JButton addButton = new javax.swing.JButton();
	javax.swing.JButton removeButton = new javax.swing.JButton();
	javax.swing.JTextArea outputFileText = new javax.swing.JTextArea();
	javax.swing.JButton outputButton = new javax.swing.JButton();
	DnDList sequenceList = new DnDList();
	javax.swing.JLabel outputLabel = new javax.swing.JLabel();
	javax.swing.JLabel sequencesLabel = new javax.swing.JLabel();
// END GENERATED CODE
	
	javax.swing.JPanel clustalPanel = new javax.swing.JPanel();
	javax.swing.JLabel gapOpenLabel = new javax.swing.JLabel();
	javax.swing.JTextField gapOpenText = new javax.swing.JTextField();
	javax.swing.JLabel gapExtendLabel = new javax.swing.JLabel();
	javax.swing.JTextField gapExtendText = new javax.swing.JTextField();

	javax.swing.JPanel parentPanel = new javax.swing.JPanel();
	javax.swing.JTabbedPane alignmentOptionPane = new JTabbedPane();	/**< contains the various parameter panels */
	
	final JFileChooser fc = new JFileChooser();
	JScrollPane listScrollPane = new JScrollPane();
	DefaultListModel sequenceListModel = new DefaultListModel(); 

	public AlignFrame() {
		setResizable( false );
	}

	public void initComponents() throws Exception {
// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
		// the following code sets the frame's initial state
		parameterPanel.setSize(new java.awt.Dimension(350, 150));
		parameterPanel.setLocation(new java.awt.Point(0, 210));
		parameterPanel.setVisible(true);
		parameterPanel.setLayout(null);
		defaultSeedCheckBox.setVisible(true);
		defaultSeedCheckBox.setSize(new java.awt.Dimension(140, 20));
		defaultSeedCheckBox.setText("Default seed size");
		defaultSeedCheckBox.setSelected(true);
		defaultSeedCheckBox.setLocation(new java.awt.Point(10, 10));
		defaultSeedCheckBox.setToolTipText("Selecting this will cause Mauve to choose the minimum seed size automatically.");
		determineLCBsCheckBox.setVisible(true);
		determineLCBsCheckBox.setSize(new java.awt.Dimension(140, 20));
		determineLCBsCheckBox.setText("Determine LCBs");
		determineLCBsCheckBox.setSelected(true);
		determineLCBsCheckBox.setLocation(new java.awt.Point(10, 90));
		determineLCBsCheckBox.setToolTipText("Selecting this will cause Mauve to determine Locally Collinear Blocks.  Without this option, all multi-MUMs will be displayed.");
		seedSlider.setSize(new java.awt.Dimension(130, 50));
		seedSlider.setLocation(new java.awt.Point(200, 30));
		seedSlider.setVisible(true);
		seedSlider.setMajorTickSpacing(4);
		seedSlider.setMinorTickSpacing(2);
		seedSlider.setMinimum( 3 );
		seedSlider.setMaximum( 31 );
		seedSlider.setPaintLabels( true );
		seedSlider.setPaintTicks( true );
		seedSlider.setSnapToTicks( true );
		seedSlider.setValue( 23 );
		seedSlider.setEnabled( false );
		seedSlider.setToolTipText("This sets the minimum size of multi-MUMs found during the first pass of match detection");
		merSizeLabel.setSize(new java.awt.Dimension(120, 20));
		merSizeLabel.setLocation(new java.awt.Point(210, 10));
		merSizeLabel.setVisible(true);
		merSizeLabel.setText("Match Seed Size:");
		merSizeLabel.setEnabled( false );
		recursiveCheckBox.setVisible(true);
		recursiveCheckBox.setSize(new java.awt.Dimension(120, 20));
		recursiveCheckBox.setText("Full Alignment");
		recursiveCheckBox.setSelected(true);
		recursiveCheckBox.setLocation(new java.awt.Point(225, 90));
		recursiveCheckBox.setToolTipText("This enables recursive anchor search and gapped alignment using ClustalW");
		minRangeLabel.setSize(new java.awt.Dimension(140, 20));
		minRangeLabel.setLocation(new java.awt.Point(135, 120));
		minRangeLabel.setVisible(true);
		minRangeLabel.setText("Minimum LCB weight:");
		minRangeText.setVisible(true);
		minRangeText.setSize(new java.awt.Dimension(60, 20));
		minRangeText.setLocation(new java.awt.Point(270, 120));
		minRangeText.setText("default");
		minRangeText.setToolTipText("LCBs below this weight will be removed from the alignment");
		islandSizeLabel.setSize(new java.awt.Dimension(135, 20));
		islandSizeLabel.setLocation(new java.awt.Point(135, 160));
		islandSizeLabel.setVisible(true);
		islandSizeLabel.setText("Minimum Island Size:");
		islandSizeText.setVisible(true);
		islandSizeText.setSize(new java.awt.Dimension(60, 20));
		islandSizeText.setLocation(new java.awt.Point(270, 160));
		islandSizeText.setText("50");
		backboneGapSizeLabel.setSize(new java.awt.Dimension(185, 20));
		backboneGapSizeLabel.setLocation(new java.awt.Point(85, 200));
		backboneGapSizeLabel.setVisible(true);
		backboneGapSizeLabel.setText("Maximum Backbone Gap Size:");
		backboneGapSizeText.setVisible(true);
		backboneGapSizeText.setSize(new java.awt.Dimension(60, 20));
		backboneGapSizeText.setLocation(new java.awt.Point(270, 200));
		backboneGapSizeText.setText("50");
		backboneGapSizeText.setToolTipText("Segments of backbone may not contain gaps larger than the given size");
		backboneSizeLabel.setSize(new java.awt.Dimension(155, 20));
		backboneSizeLabel.setLocation(new java.awt.Point(115, 240));
		backboneSizeLabel.setVisible(true);
		backboneSizeLabel.setText("Minimum Backbone Size:");
		backboneSizeText.setVisible(true);
		backboneSizeText.setSize(new java.awt.Dimension(60, 20));
		backboneSizeText.setLocation(new java.awt.Point(270, 240));
		backboneSizeText.setText("50");
		backboneSizeText.setToolTipText("Segments of backbone must contain at least this many nucleotides without a gap larger than the minimum backbone gap size");
		alignButton.setVisible(true);
		alignButton.setSize(new java.awt.Dimension(80, 30));
		alignButton.setText("Align...");
		alignButton.setLocation(new java.awt.Point(250, 320));
		sequencesPanel.setSize(new java.awt.Dimension(350, 210));
		sequencesPanel.setLocation(new java.awt.Point(0, 0));
		sequencesPanel.setVisible(true);
		sequencesPanel.setLayout(null);
		addButton.setVisible(true);
		addButton.setSize(new java.awt.Dimension(145, 20));
		addButton.setText("Add Sequence...");
		addButton.setLocation(new java.awt.Point(30, 150));
		removeButton.setVisible(true);
		removeButton.setSize(new java.awt.Dimension(145, 20));
		removeButton.setText("Remove Sequence");
		removeButton.setLocation(new java.awt.Point(185, 150));
		outputFileText.setVisible(true);
		outputFileText.setSize(new java.awt.Dimension(220, 20));
		outputFileText.setLocation(new java.awt.Point(85, 180));
		outputFileText.setToolTipText("The path and base file name for output files");
		outputButton.setVisible(true);
		outputButton.setSize(new java.awt.Dimension(20, 20));
		outputButton.setText("...");
		outputButton.setLocation(new java.awt.Point(310, 180));
		outputButton.setToolTipText("Browse to a location");
		sequenceList.setModel( sequenceListModel );
		sequenceList.setVisible(true);
		sequenceList.setSize(new java.awt.Dimension(320, 110));
//		sequenceList.setLocation(new java.awt.Point(10, 30));
		listScrollPane.getViewport().setView(sequenceList);
		listScrollPane.setSize(new java.awt.Dimension(320, 110));
		listScrollPane.setLocation(new java.awt.Point(10, 30));
		outputLabel.setSize(new java.awt.Dimension(75, 20));
		outputLabel.setLocation(new java.awt.Point(10, 180));
		outputLabel.setVisible(true);
		outputLabel.setText("Output File:");
		sequencesLabel.setSize(new java.awt.Dimension(130, 20));
		sequencesLabel.setLocation(new java.awt.Point(10, 10));
		sequencesLabel.setVisible(true);
		sequencesLabel.setText("Sequences to align:");
		setLocation(new java.awt.Point(0, 0));
		setLayout(null);
		setTitle("Align sequences...");

		parameterPanel.add(defaultSeedCheckBox);
		parameterPanel.add(determineLCBsCheckBox);
		parameterPanel.add(seedSlider);
		parameterPanel.add(merSizeLabel);
		parameterPanel.add(recursiveCheckBox);
		parameterPanel.add(minRangeLabel);
		parameterPanel.add(minRangeText);
		parameterPanel.add(islandSizeLabel);
		parameterPanel.add(islandSizeText);
		parameterPanel.add(backboneGapSizeLabel);
		parameterPanel.add(backboneGapSizeText);
		parameterPanel.add(backboneSizeLabel);
		parameterPanel.add(backboneSizeText);
		sequencesPanel.add(addButton);
		sequencesPanel.add(removeButton);
		sequencesPanel.add(outputFileText);
		sequencesPanel.add(outputButton);
		sequencesPanel.add(listScrollPane);
		sequencesPanel.add(outputLabel);
		sequencesPanel.add(sequencesLabel);
//		add(parameterPanel);
//		add(sequencesPanel);

		parentPanel.setSize( new java.awt.Dimension(350, 360));
		parentPanel.setLocation(new java.awt.Point(0, 0));
		parentPanel.setVisible( true );
		parentPanel.setLayout( null );

		alignmentOptionPane.addTab( "Files", sequencesPanel );
		alignmentOptionPane.addTab( "Parameters", parameterPanel );
//		alignmentOptionPane.setSelectedIndex( 0 );
		alignmentOptionPane.setSize(new java.awt.Dimension(350, 310));
		alignmentOptionPane.setLocation(new java.awt.Point(0, 0));
		alignmentOptionPane.setVisible( true );

		parentPanel.add(alignmentOptionPane);
		parentPanel.add(alignButton);

		add( parentPanel );

		setSize(new java.awt.Dimension(343, 383));
		
		// event handling
		
		defaultSeedCheckBox.addActionListener( new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				defaultSeedCheckBoxActionPerformed(e);
			}
		});
		
		determineLCBsCheckBox.addActionListener( new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				determineLCBsCheckBoxActionPerformed(e);
			}
		});

		recursiveCheckBox.addActionListener( new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				recursiveCheckBoxActionPerformed(e);
			}
		});

		addButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				addButtonActionPerformed(e);
			}
		});

		removeButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				removeButtonActionPerformed(e);
			}
		});

		outputButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				outputButtonActionPerformed(e);
			}
		});

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

// END GENERATED CODE
	}
  
  	private boolean mShown = false;
  	
	public void addNotify() {
		super.addNotify();
		
		if (mShown)
			return;
			
		// move components to account for insets
		Insets insets = getInsets();
		Component[] components = getComponents();
		for (int i = 0; i < components.length; i++) {
			Point location = components[i].getLocation();
			location.move(location.x, location.y + insets.top);
			components[i].setLocation(location);
		}

		mShown = true;
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
	}
	

	public void defaultSeedCheckBoxActionPerformed(java.awt.event.ActionEvent e) {
		if( defaultSeedCheckBox.isSelected() ){
			seedSlider.setEnabled( false );
			merSizeLabel.setEnabled( false );
		}else{
			seedSlider.setEnabled( true );
			merSizeLabel.setEnabled( true );
		}
	}

	public void determineLCBsCheckBoxActionPerformed(java.awt.event.ActionEvent e) {
		if( determineLCBsCheckBox.isSelected() ){
			recursiveCheckBox.setEnabled( true );
			minRangeLabel.setEnabled( true );
			minRangeText.setEnabled( true );
			if( recursiveCheckBox.isSelected() ){
				islandSizeLabel.setEnabled( true );
				islandSizeText.setEnabled( true );
				backboneGapSizeLabel.setEnabled( true );
				backboneGapSizeText.setEnabled( true );
				backboneSizeLabel.setEnabled( true );
				backboneSizeText.setEnabled( true );
			}
		}else{
			recursiveCheckBox.setEnabled( false );
			minRangeLabel.setEnabled( false );
			minRangeText.setEnabled( false );
			islandSizeLabel.setEnabled( false );
			islandSizeText.setEnabled( false );
			backboneGapSizeLabel.setEnabled( false );
			backboneGapSizeText.setEnabled( false );
			backboneSizeLabel.setEnabled( false );
			backboneSizeText.setEnabled( false );
		}
	}

	public void recursiveCheckBoxActionPerformed(java.awt.event.ActionEvent e) {
		if( recursiveCheckBox.isSelected() ){
			islandSizeLabel.setEnabled( true );
			islandSizeText.setEnabled( true );
			backboneGapSizeLabel.setEnabled( true );
			backboneGapSizeText.setEnabled( true );
			backboneSizeLabel.setEnabled( true );
			backboneSizeText.setEnabled( true );
		}else{
			islandSizeLabel.setEnabled( false );
			islandSizeText.setEnabled( false );
			backboneGapSizeLabel.setEnabled( false );
			backboneGapSizeText.setEnabled( false );
			backboneSizeLabel.setEnabled( false );
			backboneSizeText.setEnabled( false );
		}
	}
	public void addButtonActionPerformed(java.awt.event.ActionEvent e) {
		int returnVal = fc.showOpenDialog(this);
		
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File seq_file = fc.getSelectedFile();
			int sel_index = sequenceList.getSelectedIndex();
			if( sel_index >= 0 )
				sequenceListModel.add( sel_index, seq_file.getPath() );
			else
				sequenceListModel.addElement( seq_file.getPath() );
		}
	}
		
	public void removeButtonActionPerformed(java.awt.event.ActionEvent e) {
		int[] selection = sequenceList.getSelectedIndices();
		for( int selI = selection.length; selI > 0; selI-- ){
			sequenceListModel.removeElementAt( selection[ selI - 1 ] );
		}
	}

	public void outputButtonActionPerformed(java.awt.event.ActionEvent e) {
		int returnVal = fc.showOpenDialog(this);
		
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File seq_file = fc.getSelectedFile();
			outputFileText.setText( seq_file.getPath() );
		}
	}
	
	public boolean getRecursive(){
		return recursiveCheckBox.isSelected();
	}
	
	public int getSeedSize(){
		if( !defaultSeedCheckBox.isSelected() )
			return seedSlider.getValue();
		else
			return -1;
	}
	
	public boolean isLCBSearchEnabled(){
		return determineLCBsCheckBox.isSelected();
	}
	
	public int getMinRange(){
		try{
			return Integer.parseInt( minRangeText.getText() );
		}catch( NumberFormatException nfe ){
			return -1;
		}
	}
	
	public int getIslandSize(){
		try{
			return Integer.parseInt( islandSizeText.getText() );
		}catch( NumberFormatException nfe ){
			return -1;
		}
	}

	public int getBackboneSize(){
		try{
			return Integer.parseInt( backboneSizeText.getText() );
		}catch( NumberFormatException nfe ){
			return -1;
		}
	}

	public int getBackboneGapSize(){
		try{
			return Integer.parseInt( backboneGapSizeText.getText() );
		}catch( NumberFormatException nfe ){
			return -1;
		}
	}
	
	public String getOutput(){
		return outputFileText.getText();
	}

	public String[] getSequences(){
		String[] seqs = new String[ sequenceListModel.getSize() ];
		for( int seqI = 0; seqI < seqs.length; seqI++ )
			seqs[ seqI ] = (String)(sequenceListModel.get( seqI ));
		return seqs;
	}
}
