package org.gel.mauve;
import java.util.*;

/**
 * Key specifies the interface allowed for intervals that can be stored in an
 * interval sequence tree.
 */
/*
interface Key {
	public long getLength();
	public void cropStart( long size );
	public void cropEnd( long size );
	public Object clone();
}
*/

class GistIterator implements Iterator {
	GistNode node;
	GappedIntervalSequenceTree ist;

	GistIterator( GappedIntervalSequenceTree ist, GistNode node ) {
		this.ist = ist;
		this.node = node;
	}

//	Returns true if the iteration has more elements.
	public boolean	hasNext() {
		return ist.increment( node ) != null;
	}

//	Returns the next element in the iteration.	
	public Object next() {
		node = ist.increment( node );
		return node.key;
	}

//	Removes from the underlying collection the last element returned by the iterator (optional operation).
	public void remove() {
	
	}
}

class GistNode {
	GistNode parent;
	GistNode left;
	GistNode right;
	long length;
	long seq_length;
	GappedIntervalSequenceTree gis_tree;
	Key key;
	
	GistNode( GappedIntervalSequenceTree gis_tree ) {
		this.gis_tree = gis_tree;
	}
};


class GappedIntervalSequenceTree {
	static long end = Long.MAX_VALUE;

// SortedMap methods
	public Comparator comparator() {
		return null;
	} 
	public Object firstKey(){
		return null;
	}
	public GappedIntervalSequenceTree headMap( Object toKey ){
		return null;
	}
	public Object lastKey(){
		return null;
	}
	public GappedIntervalSequenceTree subMap( Long fromKey, Long toKey ){
		return null;
	}
	public GappedIntervalSequenceTree tailMap( Long fromKey ){
		return null;
	}

	GappedIntervalSequenceTree() {
		root = null;
	}

// Map methods
//          Removes all mappings from this map (optional operation).	
	public void clear(){
		root = null;
	}

	//          Returns true if this map contains a mapping for the specified key.	
	public boolean containsKey( Long key ){
		return true;
	}
	//          Returns true if this map maps one or more keys to the specified value.	
	public boolean containsValue(Object value){
		return true;
	}
	//          Returns a set view of the mappings contained in this map.	
	public Set entrySet(){
		return null;
	}
	//          Compares the specified object with this map for equality.	
	public boolean equals(Object o){
		return false;
	}
	//          Returns the value to which this map maps the specified key.	
	public Object get(Object key){
		return null;
	}
	//          Returns the hash code value for this map.	
	public int hashCode() {
		return 0;
	}
//	Returns true if this map contains no key-value mappings.	
	public boolean	isEmpty() {
		return root == null;
	}

//	Returns a set view of the keys contained in this map.	
	public Set	keySet() {
		return null;
	}
//	Associates the specified value with the specified key in this map (optional operation).	
	public Object put(Object key, Object value) {
		return null;
	}
//	Copies all of the mappings from the specified map to this map (optional operation).	
	public void putAll(Map t) {}
//	Removes the mapping for this key from this map if it is present (optional operation).	
	public Object remove(Object key) {
		return null;
	}
//	Returns the number of key-value mappings in this map.	
	public long size() {
		return root == null ? 0 : root.length;
	}
//	Returns a collection view of the values contained in this map.
	public Collection values() {
		return null;
	}


// interval sequence specific:
	/**
	 * Returns the total length of intervals contained in this interval sequence
	 */
//	long length();
	long nodeCount(){
		return root == null ? 0 : countNodes(root);
	}
//	long countNodes( GistNode* x = NULL );

	long sequenceLength() {
		return root == null ? 0 : root.seq_length;
	}

	GistIterator find( long seq_point ) {
		long[] position = new long[1];
		position[0] = seq_point;
		GistNode node = recursiveFind( root, position );
		splay( node );
		return new GistIterator( this, root );
	}

	GistIterator find_seqindex( long seq_point ) {
		long[] position = new long[1];
		position[0] = seq_point;
		GistNode node = recursiveSeqFind( root, position );
		splay( node );
		return new GistIterator( this, root );
	}

	long getSequenceStart( GistIterator iter ) {
		splay( iter.node );
		return root.left != null ? root.left.seq_length : 0;
	}

	long getStart( GistIterator iter ) {
		splay( iter.node );
		return root.left != null ? root.left.length : 0;
	}

	long length() {
		return root == null ? 0 : root.length;
	}
	

	GistNode root;		/**< Root of the tree */
	GistNode leftmost;	/**< Left most tree node, for begin() method */
	GistNode rightmost;	/**< Right most tree node, for end() method */

	
	void checkTree() {
		checkTree( root );
		checkNodeLengths( root );
		checkNodeSeqLengths( root );
	}
	
	/** 
	 * validate the structure of the tree, e.g. parents and children 
	 * are linked correctly
	 */
	void checkTree( GistNode cur_node ){
		if( cur_node != null ){
			if( cur_node.left != null && cur_node.left.parent != cur_node )
				System.err.println( "freakout\n" );
			if( cur_node.right != null && cur_node.right.parent != cur_node )
				System.err.println( "freakout\n" );
			checkTree( cur_node.left );
			checkTree( cur_node.right );
		}
	}
	
	/**
	 * validate that recorded subtree lengths and node lengths are consistent
	 */
	long checkNodeLengths( GistNode cur_node ){
		if( cur_node == null )
			return 0;

		long left_len = cur_node.left != null ? cur_node.left.length : 0;
		long right_len = cur_node.right != null ? cur_node.right.length : 0;
		// do left_len and right_len match the actual subtree lengths?
		if( left_len != checkNodeLengths( cur_node.left ) )
			System.err.println( "freakout\n" );
		if( right_len != checkNodeLengths( cur_node.right ) )
			System.err.println( "freakout\n" );
		// do they all sum up to the correct value?
		if( left_len + right_len + cur_node.key.getLength() != cur_node.length ){
			System.err.println( "freakout\n" );
			cur_node.key.print();
		}
		return cur_node.length;
	}

	long checkNodeSeqLengths( GistNode cur_node ){
		if( cur_node == null )
			return 0;

		long left_len = cur_node.left != null ? cur_node.left.seq_length : 0;
		long right_len = cur_node.right != null ? cur_node.right.seq_length : 0;
		// do left_len and right_len match the actual subtree lengths?
		if( left_len != checkNodeSeqLengths( cur_node.left ) )
			System.err.println( "freakout\n" );
		if( right_len != checkNodeSeqLengths( cur_node.right ) )
			System.err.println( "freakout\n" );
		// do they all sum up to the correct value?
		if( left_len + right_len + cur_node.key.getSeqLength() != cur_node.seq_length ){
			System.err.println( "freakout\n" );
			cur_node.key.print();
		}
		return cur_node.seq_length;
	}

	public Iterator insert( Key val, long point )
	{
		long[] position = new long[1];
		position[0] = point;
		GistNode new_node = new GistNode( this );
		new_node.key = (Key)val.clone();
		new_node.length = val.getLength();
		new_node.seq_length = val.getSeqLength();
		
		// just insert new_node as root if the tree is empty
		if( root == null ){
			root = new_node;
//			checkTree();
			return new GistIterator( this, new_node );
		}
		
		GistNode ins_node = recursiveFind( root, position );

		// insert the new node below ins_node
		if( position[0] > 0 && position[0] < ins_node.key.getLength() ){
			// trunc ins_node, do a right insert of new_node and the right part of ins_node
			GistNode ins_right = new GistNode( this );
			// Question:  does inserting two nodes at once violate the splay rules?
			// probably, but i'm not sure it really matters
			new_node.right = ins_right;
			ins_right.parent = new_node;
			ins_right.key = (Key)ins_node.key.clone();
			// crop the key
			ins_right.key.cropStart( position[0] );
			ins_right.length = val.getLength();
			ins_right.seq_length = val.getSeqLength();
			// question: do I need to update new_node.length or will the splay operations 
			// take care of it?

			ins_node.key.cropEnd( ins_node.key.getLength() - position[0] );
			ins_node.seq_length = ins_node.key.getSeqLength();
			ins_node.length = ins_node.key.getLength();
			// now position[0] ought to be equal to ins_node.length,
			// so new_node should get inserted right below it
		}

		if( position[0] == 0 ){
			// find the right-most child of the left subtree and insert there
			GistNode cur_node = ins_node.left;
			if( cur_node != null ){
				while( cur_node.right != null )
					cur_node = cur_node.right;
				// insert to the right of cur_node
				cur_node.right = new_node;
				new_node.parent = cur_node;
			}else{
				// insert to the left of ins_node
				ins_node.left = new_node;
				new_node.parent = ins_node;
			}
		}
		if( position[0] >= ins_node.key.getLength() ){
			// find the left-most child of the right subtree and insert there
			GistNode cur_node = ins_node.right;
			if( cur_node != null ){
				while( cur_node.left != null )
					cur_node = cur_node.left;
				// insert to the left of cur_node
				cur_node.left = new_node;
				new_node.parent = cur_node;
			}else{
				// insert to the right of ins_node
				ins_node.right = new_node;
				new_node.parent = ins_node;
			}
		}
		splay( new_node );
//		checkTree();
		return new GistIterator( this, new_node );
	}

	/**
	 * remove a range of coordinates from the sequence
	 */
	public long erase( long point, long length )
	{
		// loop while there are nodes to delete
		while( length > 0 ){
			// splay delete:  splay node X, splay node X-1
			//                delete X, patch X's right subtree onto X-1
			long[] position = new long[1];
			position[0] = point;
			GistNode del_node = recursiveFind( root, position );
			splay( del_node );
			checkTree();
			
			GistNode left_ins = null;
			if( position[0] > 0 ){
				// just crop this node down, don't delete it
				long left_len = del_node.left != null ? del_node.left.length : 0;
				if( position[0] + length < left_len + del_node.key.getLength() ){
					// this node needs something deleted from its middle...
					// split it into two separate nodes at the left delete
					// point, insert the preserved left-side portion of the node
					// and then do a single delete operation next time thru the loop

					Key left_k = (Key)del_node.key.clone();
					left_k.cropEnd( left_k.getLength() - position[0] );
					del_node.key.cropStart( position[0] );
					recalculateLengths( del_node );
					insert( left_k, point );
				}else{
					// crop from right
					length -= del_node.key.getLength() - position[0];
					del_node.key.cropEnd( del_node.key.getLength() - position[0] );
					recalculateLengths( del_node );
				}
			}else if( length < del_node.key.getLength() ){
				// crop from the left, we're done
				del_node.key.cropStart( length );
				recalculateLengths( del_node );
				length = 0;
			}else{
				// delete the whole darn thing
				if( root.left != null ){
					position[0] = root.left.length - 1;
					GistNode prev_node = recursiveFind( root, position );
					splay( prev_node );
					checkTree();
					root.right.right.parent = root;
					root.right = root.right.right;
					root.length -= del_node.key.getLength();
					root.seq_length -= del_node.key.getSeqLength();
				}else{
					// just delete root
					if( root.right != null )
						root.right.parent = null;
					root = root.right;
				}

				point += del_node.key.getLength();
				length -= del_node.key.getLength();
			}
			
		}
		return 0;
	}
	
	protected void splay( GistNode node ){
		// splay operations and node naming convention taken from
		// http://www.cs.nyu.edu/algvis/java/SplayTree.html

		while( node.parent != null ){
			GistNode x = node;
			GistNode y = x.parent;
			GistNode z = y.parent != null ? y.parent : y;
			if( node.parent.left == node ){
				// zigging
				if( node.parent.parent == null ){
					// zig
					y.left = x.right;
					x.right = y;
				}else if( node.parent.parent.left == node.parent ){
					// zig-zig
					z.left = y.right;
					y.left = x.right;
					y.right = z;
					x.right = y;
				}else{
					// zag-zig
					z.right = x.left;
					y.left = x.right;
					x.right = y;
					x.left = z;
				}
			}else{
				if( node.parent.right != node )
					System.err.println( "Bad error on line 427" );
				// zagging
				if( node.parent.parent == null ){
					// zag
					y.right = x.left;
					x.left = y;
				}else if( node.parent.parent.left == node.parent ){
					// zig-zag	
					z.left = x.right;
					y.right = x.left;
					x.left = y;
					x.right = z;
				}else{
					// zag-zag
					z.right = y.left;
					y.right = x.left;
					y.left = z;
					x.left = y;
				}
			}
			// update parents and lengths
			x.parent = z.parent;
			if( x.parent != null ){
				if( x.parent.left == z )
					x.parent.left = x;
				else
					x.parent.right = x;
			}
			recalculateLengths( z );
			recalculateLengths( y );
			recalculateLengths( x );
		}
		root = node;
//		checkTree();
	}



	// recalculate a node's lengths and update its children's
	// parent pointers
	protected void recalculateLengths( GistNode n ){
		n.length = n.key.getLength();
		n.length += n.right != null ? n.right.length : 0;
		n.length += n.left != null ? n.left.length : 0;
		n.seq_length = n.key.getSeqLength();
		n.seq_length += n.right != null ? n.right.seq_length : 0;
		n.seq_length += n.left != null ? n.left.seq_length : 0;
		
		if( n.left != null )
			n.left.parent = n;
		if( n.right != null )
			n.right.parent = n;
	}

	/**
	 * version 2 of recursiveFind -- don't build a potentially huge call stack!
	 */
	GistNode recursiveFind( GistNode cur_node, long[] position ){
		while( cur_node != null ){

			long left_len = cur_node.left != null ? cur_node.left.length : 0;
			if( cur_node.left != null && position[0] < cur_node.left.length ){
				cur_node = cur_node.left;
				continue;
			}

			// it's not part of the left subtree, subtract off the left subtree length
			position[0] -= left_len;
			if( cur_node.right != null && position[0] >= cur_node.key.getLength() ){
				position[0] -= cur_node.key.getLength();
				cur_node = cur_node.right;
				continue;
			}
			
			// return this node if nothing else can be done
			return cur_node;
		}
		return null;
	}
/*
	GistNode recursiveFind( GistNode cur_node, long[] position ){
		if( cur_node == null )
			return null;
		long left_len = cur_node.left != null ? cur_node.left.length : 0;
		if( cur_node.left != null && position[0] < cur_node.left.length )
			return recursiveFind( cur_node.left, position );

		// it's not part of the left subtree, subtract off the left subtree length
		position[0] -= left_len;
		if( cur_node.right != null && position[0] >= cur_node.key.getLength() ){
			position[0] -= cur_node.key.getLength();
			return recursiveFind( cur_node.right, position );
		}
		
		// return this node if nothing else can be done
		return cur_node;
	}
*/


	/**
	 * version 2 of recursiveSeqFind -- don't build a potentially huge call stack!
	 */
	GistNode recursiveSeqFind( GistNode cur_node, long[] position ){
		while( cur_node != null ){
			long left_len = cur_node.left != null ? cur_node.left.seq_length : 0;
			if( cur_node.left != null && position[0] < cur_node.left.seq_length ){
				cur_node = cur_node.left;
				continue;
			}

			// it's not part of the left subtree, subtract off the left subtree length
			position[0] -= left_len;
			if( cur_node.right != null && position[0] >= cur_node.key.getSeqLength() ){
				position[0] -= cur_node.key.getSeqLength();
				cur_node = cur_node.right;
				continue;
			}
			
			// return this node if nothing else can be done
			return cur_node;
		}
		return null;
	}

/*	GistNode recursiveSeqFind( GistNode cur_node, long[] position ){
		if( cur_node == null )
			return null;
		long left_len = cur_node.left != null ? cur_node.left.seq_length : 0;
		if( cur_node.left != null && position[0] < cur_node.left.seq_length )
			return recursiveSeqFind( cur_node.left, position );

		// it's not part of the left subtree, subtract off the left subtree length
		position[0] -= left_len;
		if( cur_node.right != null && position[0] >= cur_node.key.getSeqLength() ){
			position[0] -= cur_node.key.getSeqLength();
			return recursiveSeqFind( cur_node.right, position );
		}
		
		// return this node if nothing else can be done
		return cur_node;
	}
*/	
	
	/**
	 * Convert a sequence coordinate to a column index
	 */
	long seqPosToColumn( long seq_index ){
		GistIterator l_iter = find_seqindex( seq_index );
		long fk_left_seq_off = getSequenceStart( l_iter );
		long fk_left_col = getStart( l_iter );
		fk_left_col += seq_index - fk_left_seq_off;
		return fk_left_col;
	}
	/**
	 * Convert a column index to a sequence index, taking the nearest seq index to the
	 * left if the column falls in a gap region
	 */
	long columnToSeqPos( long column ){
		GistIterator l_iter = find( column );
		long seq_off = getSequenceStart( l_iter );
		long left_col = getStart( l_iter );
		if( column != left_col && l_iter.node.key.getSeqLength() != 0 )
			seq_off += column - left_col;
		return seq_off;
	}

	long countNodes( GistNode x ) {
		if( x == null )
			return 0;
		return countNodes( x.left ) + countNodes( x.right ) + 1;
	}


	GistNode increment( GistNode x) {

		// if x has a right child, find its leftmost descendant
		if( x.right != null ){
			GistNode leftie = x.right;
			while( leftie.left != null )
				leftie = leftie.left;
			return leftie;
		}

		// look for the least ancestor where x was the left descendant
		while( x.parent != null ){
			if( x.parent.left == x )
				return x.parent;
			x = x.parent;
		}

		// x is already the right-most tree value
		return null;
		
	}

	GistNode decrement( GistNode x) {
		
		// if x has a left child, find its rightmost descendant
		if( x.left != null ){
			GistNode rightie = x.left;
			while( rightie.right != null )
				rightie = rightie.right;
			return rightie;
		}

		// look for the least ancestor where x was the right descendant
		while( x.parent != null ){
			if( x.parent.right == x )
				return x.parent;
			x = x.parent;
		}
		
		// x is already the left-most tree value
		return null;
	}

}	







/* these are splaying from the root... i don't think this is the proper behavior
	protected void splay( long point ) {
		// splay the node containing "point" to the root of the tree
		// each node records the length of its entire subtree
		
		// splay operations and node naming convention taken from
		// http://www.cs.nyu.edu/algvis/java/SplayTree.html
		
		if( root == null )
			return;
		
		GistNode x = null;
		GistNode y = null;
		GistNode z = null;

		long left_len = root.left == null ? 0 : root.left.length;
		
		if( root.left != null && point < left_len ){
			long leftleft_len = root.left.left == null ? 0 : root.left.left.length;
			
			if( root.left.left != null && point < leftleft_len ){
				// zig-zig
				rotate(1);
			}else if( point >= leftleft_len + root.left.key.getLength() ){
				// zig-zag	
				rotate(2);
			}else{
				// zig
				rotate(3);
			}
			
		}else
		if( root.right != null && point >= left_len + root.key.getLength() ){
			long rightleft_len = root.right.left == null ? 0 : root.right.left.length;
			
			if( root.right.right != null && point >= left_len + root.key.getLength() + rightleft_len + root.right.key.getLength() ){
				// zag-zag
				rotate(4);
			}else if( root.right.left != null && point < left_len + root.key.getLength() + root.right.left.length ){
				// zag-zig
				rotate(5);
			}else{
				// zag
				rotate(6);
			}
		}else{
			// can't do anything, just exit
			return;
		}
	}
	
	protected void splay_seqindex( long point ) {
		// splay the node containing "point" to the root of the tree
		// each node records the length of its entire subtree
		
		
		if( root == null )
			return;

		long left_len = root.left == null ? 0 : root.left.seq_length;
		
		if( root.left != null && point < left_len ){
			long leftleft_len = root.left.left == null ? 0 : root.left.left.seq_length;
			
			if( root.left.left != null && point < leftleft_len )
				rotate(1);	// zig-zig
			else if( point >= leftleft_len + root.left.key.getSeqLength() )
				rotate(2);	// zig-zag
			else
				rotate(3);	// zig
			
		}else
		if( root.right != null && point >= left_len + root.key.getSeqLength() ){
			long rightleft_len = root.right.left == null ? 0 : root.right.left.seq_length;
			
			if( root.right.right != null && point >= left_len + root.key.getSeqLength() + rightleft_len + root.right.key.getSeqLength() )
				rotate(4);	// zag-zag
			else if( root.right.left != null && point < left_len + root.key.getSeqLength() + root.right.left.seq_length )
				rotate(5);	// zag-zig
			else
				rotate(6);	// zag
		}else{
			// can't do anything, just exit
			return;
		}

	}
*/
